local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local spec
local _
local sct

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	x.TimeToDie = s.TimeToDie("target") or 15
	x.GCD, _ = s.GlobalCooldown()
	x.GCD = x.GCD + x.Lag
	x.CurrentFocus = s.Power("player", SPELL_POWER_FOCUS)
	x.MaxFocus = s.MaxPower("player", SPELL_POWER_FOCUS)
	x.FocusPerSecond = a.focusRegeneration()
	x.TimeToMax = (x.MaxFocus - x.CurrentFocus) / x.FocusPerSecond
	x.Spec = s.Spec()
	a.Flash("Call Pet")
	a.Flash("Mend Pet")
	a.Flash("Pet Attack")
	a.Flash("Pet Assist")
	a.Flash("Concussive Shot")
	a.Flash("Disengage")
	a.Flash("Feign Death")
	a.Flash("Master's Call")
	a.Flash("Exhilaration")
	a.Flash("Counter Shot")
	x.InCombat = s.InCombat()
	x.Stop = false
	x.Boss = s.Boss("target")
	x.ActiveEnemies = a.ActiveEnemies()
	x.TalentStampedeEnabled = s.HasTalent(121818--[[Stampede]])
	x.TalentFocusingShotEnabled = s.HasTalent(152245--[[Focusing Shot]])
	if not x.InCombat and x.EnemyDetected then
		a.FlashAll("flask,type=greater_draenic_agility_flask",
				   "potion,name=draenic_agility")
	end
	if x.Spec == 1 then
		-- BM
		if x.TalentFocusingShotEnabled then
			sct = s.Casting(152245--[[Focusing Shot]], "player")
		else
			sct = s.Casting(77767--[[Cobra Shot]], "player")
		end
		if sct then
			x.Focus = x.CurrentFocus + sct * x.FocusPerSecond + s.If(x.TalentFocusingShotEnabled, 50, 14)
		else
			x.Focus = x.CurrentFocus + x.GCD * x.FocusPerSecond
		end
		x.FocusDeficit = x.MaxFocus - x.Focus
		x.TimeToMax = (x.MaxFocus - x.Focus) / x.FocusPerSecond
		x.BuffBestialWrathRemains = s.BuffDuration(19574--[[Bestial Wrath]], "player", nil, false, false, true)
		x.BuffFocusFireRemains = s.BuffDuration(82692--[[Focus Fire]], "player", nil, false, false, true)
		a.Flash("auto_shot",
--				"use_item,name=beating_heart_of_the_mountain",
				"arcane_torrent,if=focus.deficit>=30",
				"blood_fury",
				"berserking",
				"potion,name=draenic_agility,if=!talent.stampede.enabled&buff.bestial_wrath.up|target.time_to_die<=20",
				"potion,name=draenic_agility,if=talent.stampede.enabled&cooldown.stampede.remains<1&(buff.bloodlust.up|buff.focus_fire.up)|target.time_to_die<=20",
				"stampede,if=buff.bloodlust.up|buff.focus_fire.up|target.time_to_die<=20",
				"dire_beast",
				"explosive_trap,if=active_enemies>2",
				"bestial_wrath,if=focus>60&!buff.bestial_wrath.up",
				"barrage,if=active_enemies>2",
				"multishot,if=active_enemies>5|(active_enemies>1&pet.cat.buff.beast_cleave.down)",
				"barrage,if=active_enemies>1",
				"a_murder_of_crows",
				"kill_shot,if=focus.time_to_max>gcd",
				"kill_command",
				"focusing_shot,if=focus<50",
				--Cast a second shot for steady focus if that won't cap us.
				"cobra_shot,if=buff.pre_steady_focus.up&(14+cast_regen)<=focus.deficit",
				"glaive_toss",
				"barrage",
				"powershot,if=focus.time_to_max>cast_time",
				"cobra_shot,if=active_enemies>5",
				"arcane_shot,if=(buff.thrill_of_the_hunt.react&focus>35)|buff.bestial_wrath.up",
				"focus_fire,five_stacks=1",
				"arcane_shot,if=focus>=64",
				"cobra_shot")
	elseif x.Spec == 2 then
		-- MM
		if x.TalentFocusingShotEnabled then
			sct = s.Casting(152245--[[Focusing Shot]], "player")
		else
			sct = s.Casting(56641--[[Steady Shot]], "player")
		end
		if sct then
			x.Focus = x.CurrentFocus + sct * x.FocusPerSecond + s.If(x.TalentFocusingShotEnabled, 50, 14)
		else
			x.Focus = x.CurrentFocus + x.GCD * x.FocusPerSecond
		end
		x.BuffThrillOfTheHuntRemains = s.BuffDuration(34720--[[Thrill of the Hunt]], "player", nil, false, false, true)
		if s.Casting(19434--[[Aimed Shot]], "player") then
			if x.BuffThrillOfTheHuntRemains > x.Lag then
				x.Focus = x.Focus - 30
			else
				x.Focus = x.Focus - 50
			end
		end
		x.BuffRapidFireRemaining = s.BuffDuration(3045--[[Rapid Fire]], "player", nil, false, false, true)
		x.CooldownRapidFireRemains = s.SpellCooldown(3045--[[Rapid Fire]])
		x.FocusDeficit = x.MaxFocus - x.Focus
		if s.HealthPercent("target") <= 80 or s.Dummy("target") or x.BuffRapidFireRemaining <= x.Lag then
			x.AimedShotCastRegen = s.CastTime(19434--[[Aimed Shot]]) * x.FocusPerSecond
			a.Flash("auto_shot",
					"arcane_torrent,if=focus.deficit>=30",
					"blood_fury",
					"berserking",
					"potion,name=draenic_agility,if=((buff.rapid_fire.up|buff.bloodlust.up)&(!talent.stampede.enabled|cooldown.stampede.remains<1))|target.time_to_die<=20",
					"kill_shot,if=cast_regen+action.aimed_shot.cast_regen<focus.deficit",
					"chimaera_shot",
					"rapid_fire",
					"stampede,if=buff.rapid_fire.up|buff.bloodlust.up|target.time_to_die<=20",
					"explosive_trap,if=active_enemies>2",
					"a_murder_of_crows",
					"dire_beast,if=cast_regen+action.aimed_shot.cast_regen<focus.deficit",
					"glaive_toss",
					"powershot,if=cast_regen<focus.deficit",
					"barrage",
					-- Pool max focus for rapid fire so we can spam AimedShot with Careful Aim buff
					"steady_shot,if=focus.deficit*cast_time%(14+cast_regen)>cooldown.rapid_fire.remains",
					"focusing_shot,if=focus.deficit*cast_time%(50+cast_regen)>cooldown.rapid_fire.remains&focus<100",
					-- Cast a second shot for steady focus if that won't cap us.
					"steady_shot,if=buff.pre_steady_focus.up&(14+cast_regen+action.aimed_shot.cast_regen)<=focus.deficit",
					"aimed_shot,if=talent.focusing_shot.enabled",
					"aimed_shot,if=focus+cast_regen>=85",
					"aimed_shot,if=buff.thrill_of_the_hunt.react&focus+cast_regen>=65",
					-- Allow FS to over-cap by 10 if we have nothing else to do
					"focusing_shot,if=50+cast_regen-10<focus.deficit",
					"steady_shot")
		else
			a.Flash("auto_shot",
					"arcane_torrent,if=focus.deficit>=30",
					"blood_fury",
					"berserking",
					"potion,name=draenic_agility,if=((buff.rapid_fire.up|buff.bloodlust.up)&(!talent.stampede.enabled|cooldown.stampede.remains<1))|target.time_to_die<=20",
					"kill_shot,if=cast_regen+action.aimed_shot.cast_regen<focus.deficit",
					"chimaera_shot",
					"rapid_fire",
					"stampede,if=buff.rapid_fire.up|buff.bloodlust.up|target.time_to_die<=20",
					"glaive_toss,if=active_enemies>4",
					"powershot,if=active_enemies>1&cast_regen<focus.deficit",
					"barrage,if=active_enemies>1",
					"aimed_shot",
					"focusing_shot,if=50+cast_regen<focus.deficit",
					"steady_shot")
		end
	elseif x.Spec == 3 then
		-- SV
		x.TrinketBuffUp = s.Buff({177597--[["Lucky" Flip]],
			177172--[[Archmage's Greater Incandescence]],
			177067--[[Detonation]],
			177038--[[Balanced Fate]],
			177035--[[Meaty Dragonspine Trophy]],
			176939--[[Formidable Jar of Doom]],
			176883--[[Turbulent Vial of Toxin]],
			176878--[[Lub-Dub]],
			165830--[[Critical Strike]],
			165822--[[Haste]],
			165542--[[Multi-Strike]],
			165485--[[Mastery]],
			162915--[[Spirit of the Warlords]],
			133630--[[Exquisite Proficiency]],
			126554--[[Agile]]}, "player", nil, false, false, true)		
		if x.TalentFocusingShotEnabled then
			sct = s.Casting(152245--[[Focusing Shot]], "player")
		else
			sct = s.Casting(77767--[[Cobra Shot]], "player")
		end
		if sct then
			x.Focus = x.CurrentFocus + sct * x.FocusPerSecond + s.If(x.TalentFocusingShotEnabled, 50, 14)
		else
			x.Focus = x.CurrentFocus + x.GCD * x.FocusPerSecond
		end
		x.FocusDeficit = x.MaxFocus - x.Focus
		if x.ActiveEnemies <= 1 then
			a.Flash("auto_shot",
--					"use_item,name=beating_heart_of_the_mountain",
					"arcane_torrent,if=focus.deficit>=30",
					"blood_fury",
					"berserking",
					"potion,name=draenic_agility,if=(((cooldown.stampede.remains<1|!talent.stampede.enabled)&(!talent.a_murder_of_crows.enabled|cooldown.a_murder_of_crows.remains<1))&(trinket.stat.any.up|buff.archmages_greater_incandescence_agi.up))|target.time_to_die<=20",
					"stampede,if=buff.potion.up|(cooldown.potion.remains&(buff.archmages_greater_incandescence_agi.up|trinket.stat.any.up))",
					"explosive_shot",
					"black_arrow,if=!ticking",
					"a_murder_of_crows",
					"dire_beast",
					"arcane_shot,if=buff.thrill_of_the_hunt.react&focus>35&cast_regen<=focus.deficit|dot.serpent_sting.remains<=5|target.time_to_die<4.5",
					"glaive_toss",
					"powershot",
					"barrage",
					-- Cast a second shot for steady focus if that won't cap us.
					"cobra_shot,if=buff.pre_steady_focus.up&buff.steady_focus.remains<5&(14+cast_regen)<=focus.deficit<80",
					"arcane_shot,if=focus>=70|talent.focusing_shot.enabled",
					"focusing_shot",
					"cobra_shot")
		else
			a.Flash("auto_shot",
--					"use_item,name=beating_heart_of_the_mountain",
					"arcane_torrent,if=focus.deficit>=30",
					"blood_fury",
					"berserking",
					"potion,name=draenic_agility,if=(((cooldown.stampede.remains<1|!talent.stampede.enabled)&(!talent.a_murder_of_crows.enabled|cooldown.a_murder_of_crows.remains<1))&(trinket.stat.any.up|buff.archmages_greater_incandescence_agi.up))|target.time_to_die<=20",
					"stampede,if=buff.potion.up|(cooldown.potion.remains&(buff.archmages_greater_incandescence_agi.up|trinket.stat.any.up|buff.archmages_incandescence_agi.up))",
					"explosive_shot,if=buff.lock_and_load.react&(!talent.barrage.enabled|cooldown.barrage.remains>0)",
					"barrage",
					"explosive_shot,if=active_enemies<5",
					"black_arrow,if=!ticking",
					"explosive_trap,if=dot.explosive_trap.remains<=5",
					"a_murder_of_crows",
					"dire_beast",
					"multishot,if=buff.thrill_of_the_hunt.react&focus>50&cast_regen<=focus.deficit|dot.serpent_sting.remains<=5|target.time_to_die<4.5",
					"glaive_toss",
					"powershot",
					"cobra_shot,if=buff.pre_steady_focus.up&buff.steady_focus.remains<5&focus+14+cast_regen<80",
					"multishot,if=focus>=70|talent.focusing_shot.enabled",
					"focusing_shot",
					"cobra_shot")
		end
	end
end)

